#ifndef _SIMPLICIAL_COMPLEX_EDGE_TET_ITERATOR_H_
#define _SIMPLICIAL_COMPLEX_EDGE_TET_ITERATOR_H_


//////////////////////////////////////////////////////////////////////////////
// Includes

#include "simplicialComplex/tet.h"
#include <vector>

class Edge;


//////////////////////////////////////////////////////////////////////////////
// class EdgeTetIterator
//

class EdgeTetIterator
{
public:  // methods
    EdgeTetIterator( const Edge& v );
    ~EdgeTetIterator() {}

    EdgeTetIterator& operator++();
    EdgeTetIterator operator++(int);

    const Tet& operator*() const;
    const Tet* operator->() const;

    operator bool() const;

private:  // methods
    EdgeTetIterator();

private:  // data
    std::vector<size_t>::const_iterator m_iter;
    std::vector<size_t>::const_iterator m_end;
    Tet m_tet;
};


inline EdgeTetIterator& EdgeTetIterator::operator++()
{
    ++m_iter;
    if(*this) m_tet.index = (*m_iter);
    else      m_tet.index = size_t(-1);
    return (*this);
}

inline EdgeTetIterator EdgeTetIterator::operator++(int)
{
    EdgeTetIterator iterator = *this;
    ++(*this);
    return iterator;
}

inline const Tet& EdgeTetIterator::operator*() const
{
    return m_tet;
}

inline const Tet* EdgeTetIterator::operator->() const
{
    return &m_tet;
}

inline EdgeTetIterator::operator bool() const
{
    return (m_iter != m_end);
}


#endif  // _SIMPLICIAL_COMPLEX_EDGE_TET_ITERATOR_H_
