
#ifndef _BBOX_H_
#define _BBOX_H_


#include "util/linear.h"


class BBox
{
public:
    BBox() {}
    BBox( const vec3& _min,const vec3& _max ): vmin(_min),vmax(_max) {}

    void SetMin(const vec3& _min) { vmin=_min; }
    void SetMin(real x, real y, real z) { vmin[0]=x; vmin[1]=y; vmin[2]=z; }
    void SetMax(const vec3& _max) { vmax=_max; }
    void SetMax(real x, real y, real z) { vmax[0]=x; vmax[1]=y; vmax[2]=z; }

    void SetBounds(const vec3& _min,const vec3& _max) { vmin=_min; vmax=_max; }
    void SetBounds(real xmin, real ymin, real zmin, real xmax, real ymax, real zmax) 
        { vmin[0]=xmin; vmin[1]=ymin; vmin[2]=zmin; vmax[0]=xmax; vmax[1]=ymax; vmax[2]=zmax; }
    void GetBounds(vec3& _min, vec3& _max) { _min=vmin; _max=vmax; }
    void GetBounds(real &xmin, real &ymin, real &zmin, real &xmax, real &ymax, real &zmax) 
        { xmin=vmin[0]; ymin=vmin[1]; zmin=vmin[2]; xmax=vmax[0]; ymax=vmax[1]; zmax=vmax[2]; }

    const vec3& GetMin() const { return vmin; }
    const vec3& GetMax() const { return vmax; }
    vec3& GetMin() { return vmin; }
    vec3& GetMax() { return vmax; }

    vec3 GetCenter() const { return (real)0.5*(vmin+vmax); }

    //intersect with another box
    bool Intersect(const BBox& bb) const;

    //intersect with a point
    bool Intersect(const vec3& point) const;

private:
    vec3 vmin, vmax;
};


#endif  // _BBOX_H_
